ON_BrepTrim Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_brep.h>`

Inheritance diagram for ON_BrepTrim:

## Public Types

enum | TYPE { unknown = 0, boundary = 1, mated = 2, seam = 3, singular = 4, crvonsrf = 5, ptonsrf = 6, slit = 7, trim_type_count = 8, force_32_bit_trim_type = 0xFFFFFFFF }

## Public Member Functions

void | DestroyRuntimeCache (bool bDelete=true)
unsigned int | SizeOf () const
| ON_BrepTrim ()
| ON_BrepTrim (int)
ON_BrepTrim & | operator= (const ON_BrepTrim &)
ON_Brep * | Brep () const
ON_BrepLoop * | Loop () const
ON_BrepFace * | Face () const
ON_BrepEdge * | Edge () const
ON_BrepVertex * | Vertex (int tvi) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON_COMPONENT_INDEX | ComponentIndex () const
ON_BOOL32 | Reverse ()
ON_BOOL32 | SetStartPoint (ON_3dPoint start_point)
ON_BOOL32 | SetEndPoint (ON_3dPoint end_point)
bool | ChangeTrimCurve (int c2i)
void | DestroyPspaceInformation ()
bool | RemoveFromEdge (bool bRemoveFromStartVertex, bool bRemoveFromEndVertex)
bool | AttachToEdge (int edge_index, bool bRev3d)
const ON_Curve * | TrimCurveOf () const
const ON_Curve * | EdgeCurveOf () const
const ON_Surface * | SurfaceOf () const
int | TrimCurveIndexOf () const
int | EdgeCurveIndexOf () const
int | SurfaceIndexOf () const
int | FaceIndexOf () const
bool | IsSlit () const
bool | IsSeam () const
bool | TransformTrim (const ON_Xform &xform)
void | UnsetPlineEdgeParameters ()
void | m__legacy_flags_Set (int, int)
bool | m__legacy_flags_Get (int *, int *) const
Public Member Functions inherited from ON_CurveProxy
void | DestroyRuntimeCache (bool bDelete=true)
| ON_CurveProxy ()
| ON_CurveProxy (const ON_CurveProxy &)
| ON_CurveProxy (const ON_Curve *)
| ON_CurveProxy (const ON_Curve *, ON_Interval)
ON_CurveProxy & | operator= (const ON_CurveProxy &)
virtual | ~ON_CurveProxy ()
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
void | SetProxyCurve (const ON_Curve *real_curve)
void | SetProxyCurve (const ON_Curve *real_curve, ON_Interval real_curve_subdomain)
const ON_Curve * | ProxyCurve () const
bool | SetProxyCurveDomain (ON_Interval proxy_curve_subdomain)
ON_Interval | ProxyCurveDomain () const
bool | ProxyCurveIsReversed () const
double | RealCurveParameter (double t) const
double | ThisCurveParameter (double real_curve_parameter) const
ON_Curve * | DuplicateCurve () const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
ON_Interval | Domain () const
ON_BOOL32 | SetDomain (double t0, double t1)
bool | SetDomain (ON_Interval domain)
int | SpanCount () const
ON_BOOL32 | GetSpanVector (double *) const
int | Degree () const
ON_BOOL32 | GetParameterTolerance (double, double *, double *) const
ON_BOOL32 | IsLinear (double=ON_ZERO_TOLERANCE) const
int | IsPolyline (ON_SimpleArray< ON_3dPoint > *pline_points=NULL, ON_SimpleArray< double > *pline_t=NULL) const
ON_BOOL32 | IsArc (const ON_Plane *=NULL, ON_Arc *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsPlanar (ON_Plane *=NULL, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsInPlane (const ON_Plane &, double=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsClosed (void) const
ON_BOOL32 | IsPeriodic (void) const
bool | GetNextDiscontinuity (ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse ()
ON_BOOL32 | Evaluate (double, int, int, double *, int=0, int *=0) const
ON_BOOL32 | Trim (const ON_Interval &domain)
ON_BOOL32 | Split (double t, ON_Curve *&left_side, ON_Curve *&right_side) const
int | GetNurbForm (ON_NurbsCurve &, double=0.0, const ON_Interval *=NULL) const
int | HasNurbForm () const
ON_BOOL32 | GetCurveParameterFromNurbFormParameter (double, double *) const
ON_BOOL32 | GetNurbFormParameterFromCurveParameter (double, double *) const
Public Member Functions inherited from ON_Curve
| ON_Curve ()
| ON_Curve (const ON_Curve &)
ON_Curve & | operator= (const ON_Curve &)
virtual | ~ON_Curve ()
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
ON::object_type | ObjectType () const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | GetDomain (double *t0, double *t1) const
bool | SetDomain (ON_Interval domain)
virtual ON_BOOL32 | ChangeClosedCurveSeam (double t)
virtual bool | ChangeDimension (int desired_dimension)
virtual ON_BOOL32 | GetSpanVectorIndex (double t, int side, int *span_vector_index, ON_Interval *span_domain) const
bool | IsArcAt (double t, const ON_Plane *plane=0, ON_Arc *arc=0, double tolerance=ON_ZERO_TOLERANCE, double *t0=0, double *t1=0) const
virtual bool | IsEllipse (const ON_Plane *plane=NULL, ON_Ellipse *ellipse=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsClosable (double tolerance, double min_abs_size=0.0, double min_rel_size=10.0) const
ON_3dPoint | PointAt (double t) const
ON_3dPoint | PointAtStart () const
ON_3dPoint | PointAtEnd () const
ON_3dVector | DerivativeAt (double t) const
ON_3dVector | TangentAt (double t) const
ON_3dVector | CurvatureAt (double t) const
ON_BOOL32 | FrameAt (double t, ON_Plane &plane) const
ON_BOOL32 | EvPoint (double t, ON_3dPoint &point, int side=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, int side=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double t, ON_3dPoint &point, ON_3dVector &first_derivative, ON_3dVector &second_derivative, int side=0, int *hint=0) const
ON_BOOL32 | EvTangent (double t, ON_3dPoint &point, ON_3dVector &tangent, int side=0, int *hint=0) const
ON_BOOL32 | EvCurvature (double t, ON_3dPoint &point, ON_3dVector &tangent, ON_3dVector &kappa, int side=0, int *hint=0) const
bool | FirstSpanIsLinear (double min_length, double tolerance) const
bool | LastSpanIsLinear (double min_length, double tolerance) const
bool | FirstSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
bool | LastSpanIsLinear (double min_length, double tolerance, ON_Line *span_line) const
virtual bool | Extend (const ON_Interval &domain)
ON_NurbsCurve * | NurbsCurve (ON_NurbsCurve *pNurbsCurve=NULL, double tolerance=0.0, const ON_Interval *subdomain=NULL) const
void | DestroyCurveTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

ON_U | m_trim_user
int | m_trim_index
int | m_c2i
int | m_ei
int | m_vi [2]
bool | m_bRev3d
TYPE | m_type
ON_Surface::ISO | m_iso
int | m_li
double | m_tolerance [2]
ON_SimpleArray< ON_BrepTrimPoint > | m_pline
ON_BoundingBox | m_pbox
double | m__legacy_2d_tol
double | m__legacy_3d_tol
int | m__legacy_flags

## Friends

class | ON_Brep

## Additional Inherited Members

Protected Member Functions inherited from ON_Curve
bool | ParameterSearch (double t, int &index, bool bEnableSnap, const ON_SimpleArray< double > &m_t, double RelTol=ON_SQRT_EPSILON) const

## Detailed Description

Definition at line 414 of file opennurbs_brep.h.

## Member Enumeration Documentation

## TYPE

enum ON_BrepTrim::TYPE

Enumerator
unknown |
boundary |
mated |
seam |
singular |
crvonsrf |
ptonsrf |
slit |
trim_type_count |
force_32_bit_trim_type |

Definition at line 433 of file opennurbs_brep.h.

## Constructor & Destructor Documentation

## ON_BrepTrim() [1/2]

ON_BrepTrim::ON_BrepTrim | ( |  | ) |

## ON_BrepTrim() [2/2]

ON_BrepTrim::ON_BrepTrim | ( | int |  | ) |

## Member Function Documentation

## AttachToEdge()

bool ON_BrepTrim::AttachToEdge | ( | int | edge_index,
|  | bool | bRev3d
| ) |  |

## Brep()

ON_Brep* ON_BrepTrim::Brep | ( |  | ) | const

## ChangeTrimCurve()

bool ON_BrepTrim::ChangeTrimCurve | ( | int | c2i | ) |

## ComponentIndex()

ON_COMPONENT_INDEX ON_BrepTrim::ComponentIndex | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

## DestroyPspaceInformation()

void ON_BrepTrim::DestroyPspaceInformation | ( |  | ) |

## DestroyRuntimeCache()

void ON_BrepTrim::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_Object.

## Dump()

void ON_BrepTrim::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## Edge()

ON_BrepEdge* ON_BrepTrim::Edge | ( |  | ) | const

## EdgeCurveIndexOf()

int ON_BrepTrim::EdgeCurveIndexOf | ( |  | ) | const

## EdgeCurveOf()

const ON_Curve* ON_BrepTrim::EdgeCurveOf | ( |  | ) | const

## Face()

ON_BrepFace* ON_BrepTrim::Face | ( |  | ) | const

## FaceIndexOf()

int ON_BrepTrim::FaceIndexOf | ( |  | ) | const

## IsSeam()

bool ON_BrepTrim::IsSeam | ( |  | ) | const

## IsSlit()

bool ON_BrepTrim::IsSlit | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_BrepTrim::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## Loop()

ON_BrepLoop* ON_BrepTrim::Loop | ( |  | ) | const

## m__legacy_flags_Get()

bool ON_BrepTrim::m__legacy_flags_Get | ( | int * | ,
|  | int * |
| ) |  | const

## m__legacy_flags_Set()

void ON_BrepTrim::m__legacy_flags_Set | ( | int | ,
|  | int |
| ) |  |

## operator=()

ON_BrepTrim& ON_BrepTrim::operator= | ( | const ON_BrepTrim & |  | ) |

## Read()

ON_BOOL32 ON_BrepTrim::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## RemoveFromEdge()

bool ON_BrepTrim::RemoveFromEdge | ( | bool | bRemoveFromStartVertex,
|  | bool | bRemoveFromEndVertex
| ) |  |

## Reverse()

ON_BOOL32 ON_BrepTrim::Reverse | ( |  | ) |

virtual

Implements ON_Curve.

## SetEndPoint()

ON_BOOL32 ON_BrepTrim::SetEndPoint | ( | ON_3dPoint | end_point | ) |

virtual

Reimplemented from ON_Curve.

## SetStartPoint()

ON_BOOL32 ON_BrepTrim::SetStartPoint | ( | ON_3dPoint | start_point | ) |

virtual

Reimplemented from ON_Curve.

## SizeOf()

unsigned int ON_BrepTrim::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SurfaceIndexOf()

int ON_BrepTrim::SurfaceIndexOf | ( |  | ) | const

## SurfaceOf()

const ON_Surface* ON_BrepTrim::SurfaceOf | ( |  | ) | const

## TransformTrim()

bool ON_BrepTrim::TransformTrim | ( | const ON_Xform & | xform | ) |

## TrimCurveIndexOf()

int ON_BrepTrim::TrimCurveIndexOf | ( |  | ) | const

## TrimCurveOf()

const ON_Curve* ON_BrepTrim::TrimCurveOf | ( |  | ) | const

## UnsetPlineEdgeParameters()

void ON_BrepTrim::UnsetPlineEdgeParameters | ( |  | ) |

## Vertex()

ON_BrepVertex* ON_BrepTrim::Vertex | ( | int | tvi | ) | const

## Write()

ON_BOOL32 ON_BrepTrim::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Friends And Related Function Documentation

## ON_Brep

friend class ON_Brep

friend

Definition at line 815 of file opennurbs_brep.h.

## Member Data Documentation

## m__legacy_2d_tol

double ON_BrepTrim::m__legacy_2d_tol

Definition at line 810 of file opennurbs_brep.h.

## m__legacy_3d_tol

double ON_BrepTrim::m__legacy_3d_tol

Definition at line 811 of file opennurbs_brep.h.

## m__legacy_flags

int ON_BrepTrim::m__legacy_flags

Definition at line 812 of file opennurbs_brep.h.

## m_bRev3d

bool ON_BrepTrim::m_bRev3d

Definition at line 742 of file opennurbs_brep.h.

## m_c2i

int ON_BrepTrim::m_c2i

Definition at line 728 of file opennurbs_brep.h.

## m_ei

int ON_BrepTrim::m_ei

Definition at line 731 of file opennurbs_brep.h.

## m_iso

ON_Surface::ISO ON_BrepTrim::m_iso

Definition at line 745 of file opennurbs_brep.h.

## m_li

int ON_BrepTrim::m_li

Definition at line 748 of file opennurbs_brep.h.

## m_pbox

ON_BoundingBox ON_BrepTrim::m_pbox

Definition at line 803 of file opennurbs_brep.h.

## m_pline

ON_SimpleArray<ON_BrepTrimPoint> ON_BrepTrim::m_pline

Definition at line 792 of file opennurbs_brep.h.

## m_tolerance

double ON_BrepTrim::m_tolerance[2]

Definition at line 788 of file opennurbs_brep.h.

## m_trim_index

int ON_BrepTrim::m_trim_index

Definition at line 430 of file opennurbs_brep.h.

## m_trim_user

ON_U ON_BrepTrim::m_trim_user

Definition at line 428 of file opennurbs_brep.h.

## m_type

TYPE ON_BrepTrim::m_type

Definition at line 744 of file opennurbs_brep.h.

## m_vi

int ON_BrepTrim::m_vi[2]

Definition at line 739 of file opennurbs_brep.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_brep.h